#include <REGX51.H>
//Code by vuthai - SangTaoClub.Net
//Chu Phuc Loc Tho co tat ca 10 ky tu sd 2 post
//Tich hop duong vien 8bit (6 hieu ung) va 3bit chay song song voi nhau
//Dung muc logic 0 de lam chu sang
/****************** Khai bao chan va post xuat du lieu ***********************/
//Chu y: Khong dc khai bao trung chan voi post 
//VD: Khai bao chan P3_0 oy thi khong dc sd P3 cho cong 8bit xuat nua ma phai dung post khac
#define C1 P1  //Cong 1 8bit (P1.0-P1.7: P H U C L O C T)
#define C2 P3  //Cong 2 2bit (P2.0-P2.1: H O)
#define DV8 P0  //Duong vien 8bit
#define DV1	P2_2  //Duong vien 3bit LED 1
#define DV2	P2_1  //Duong vien 3bit LED 2
#define DV3 P2_0  //Duong vien 3bit LED 3
/****************** Chuong trinh tao tre delay ***********************/
void delay(unsigned char t){
	unsigned char i;
	unsigned int j;
	for(i=0;i<t;i++){	
		for(j=0;j<12500;j++);
	}
}
/******************* Khai bao bien chuong trinh ***************************/
unsigned int a,b,c,d,e;
unsigned char vp0,vp1,o,j,k,i,w,f,dv;
unsigned char m1[8]={0xfe,0xfc,0xf8,0xf0,0xe0,0xc0,0x80,0x00};//lan luot sang
unsigned char m2[8]={0xfe,0xfd,0xfb,0xf7,0xef,0xdf,0xbf,0x7f};//led don
unsigned char m3[8]={0x7c,0xf9,0xf3,0xe7,0xcf,0x9f,0x3f,0x7e};//DV 8bit
unsigned char m4[8]={0x7e,0x3c,0x18,0x00,0x81,0xc3,0xe7,0xff};//DV 8bit
unsigned char m5[8]={0x01,0x03,0x07,0x0f,0x1f,0x3f,0x7f,0xff};//DV 8bit
/*********************** Ctr hieu ung **********************************/
void nhap_nhay(unsigned char rep){//ctr con nhap nhay
	//Nhap nhay tat ca 10 lan
	for(w=0;w<rep;w++){
	  	C1=0x00;C2=0xfc; //sang
		delay(3);
		C1=C2=0xff; //tat
		delay(3);
	}
}
void lan_luot(){//ctr con nhay lan luot
	C1=C2=0xff;
	delay(10);
	for(w=0;w<8;w++){
		C1=m1[w];//Xuat mang m1 thuan
		delay(3);
	}
	for(w=0;w<2;w++){
		C2=m1[w];//Xuat mang m1 thuan
		delay(3);
	}
	nhap_nhay(3);
	C1=0x00; C2=0xfd;
	for(w=0;w<2;w++){
		C2=m1[1-w];//Xuat mang m1 nguoc
		delay(3);
	}
	C2=0xff;delay(5);
	for(w=0;w<8;w++){
		C1=m1[7-w];//Xuat mang m1 nguoc
		delay(3);
	}
	C1=0xff;delay(3);
}
void quet_led(){//Quet led lan luot
	C1=C2=0xff;
	delay(10);
	for(w=0;w<8;w++){
		C1=m2[w];//Xuat mang m2 thuan
		delay(2);
	} 
	C1=0xff;delay(2);
	for(w=0;w<2;w++){
		C2=m2[w];//Xuat mang m2 thuan
		delay(2);
	}
	for(w=0;w<2;w++){
		C2=m2[1-w];//Xuat mang m2 nguoc
		delay(2);
	}
	C2=0xff;delay(2);
	for(w=0;w<8;w++){
		C1=m2[7-w];//Xuat mang m2 nguoc
		delay(2);
	}
}

void xen_ke(){//ctr con nhay xen ke
	for(w=0;w<10;w++){
	  	C1=0xAA;//01010101
		C2=0xfe;
		delay(5);
		C1=0x55;//10101010
		C2=0xfd;
		delay(5);
	}
}
void nhay_dep(){
	C1=C2=0xff;delay(10);
	for(w=0;w<8;w++){
	  	for(i=0;i<3;i++){//Nhay xen ke
	  		C1=0xAA;
			C2=0xfe;
			delay(2);
			C1=0x55;
			C2=0xfd;
			delay(2);
		}
	   	C1=m1[w];//Xuat mang m1
		C2=0xff;//Tat cong 2
		delay(10);
	}
	for(w=0;w<2;w++){
	  	for(i=0;i<3;i++){//Nhay xen ke
	  		C1=0xAA;
			C2=0xfe;
			delay(2);
			C1=0x55;
			C2=0xfd;
			delay(2);
		}
	   	C2=m1[w];//Xuat mang m1
		C1=0x00;//Sang cong 1
		delay(10);
	}
}
void nhay_chu(){//ctr nhay chu
   	C1=C2=0xff;delay(5); //ALL OFF
	//1
	C1=0xf0;delay(5); //PHUC  sang
	C1=0x80;delay(5); //PHUC LOC sang
	C1=0x00;C2=0xfc;delay(5); //PHUC LOC THO sang
	C1=C2=0xff;delay(5); //ALL OFF
	//2
   	C1=0xfe;delay(5);  //P (PHUC) sang
	C1=0xef;delay(5);  //L (LOC) sang
	C1=0x7f;delay(5);  //T (THO) sang
	C1=C2=0xff;delay(5); //ALL OFF
	//3
	for(w=0;w<5;w++){
		C1=0x70;C2=0xfc;delay(6);
		C1=0x8f;C2=0xff;delay(6);
	}
	//4
	for(w=0;w<4;w++){//Quet sang tung chu
		C1=0xf0;delay(3); //PHUC
		C1=0x8f;delay(3); //LOC 
		C1=0x7f;C2=0xfc;delay(6); //THO
		C2=0xff;C1=0x8f;delay(3); //LOC
		C1=0xf0;delay(3); //PHUC	
	}
	//5
	for(w=0;w<3;w++){//Nhay chu "PHUC"
		C1=0xf0;delay(3);
		C1=0xff;delay(3);
	}  
	C1=0xf0;delay(10);//Sang chu
	for(w=0;w<3;w++){//Nhay chu "LOC"
		C1=0x80;delay(3);
		C1=0xf0;delay(3);
	}  
	C1=0x80;delay(10);
	for(w=0;w<3;w++){//Nhay chu "THO"
		C1=0x00;C2=0xfc;delay(3);
		C1=0x80;C2=0xff;delay(3);
	}   
	C1=0x00;C2=0xfc;delay(10);
	//End
}

void duoi_nhau(){//Hieu ung led duoi nhau
	C1=C2=0xff;//OFF ALL LED
	delay(10);
	for(w=1;w<8;w++){
		C1=m2[w];//Xuat mang m2	ra post vdk
		delay(3);
		C1=m2[w-1];//Xuat phan tu mang truoc do
		delay(3);
	}
	C1=0xff;delay(3);
	for(w=1;w<2;w++){
		C2=m2[w];//Xuat mang m2	ra post vdk
		delay(3);
		C2=m2[w-1];//Xuat phan tu mang truoc do
		delay(3);
	}
}

void xep_led(){//Hieu ung xep led lan luot
	a=0x03ff;//int 16bit
	for(o=0;o<10;++o){
		d=0x03ff;
		for(j=0;j<o;++j) d>>=1;//Dich phai 1bit
		a=0x03ff;
		for(j=0;j<10-o;++j){
			a<<=1;//Dich trai 1bit
			c=0;
			for(k=0;k<j;++k)
			{
				c<<=1;//Dich trai 1bit
				c|=1;
			}
			a|=c;//OR bit
			a&=d;//AND bit
			vp0=(char)a;//8bit thap
			b=a;
			b>>=8;//Dich phai 8bit de lay 8bit cao
			vp1=(char)b;//8bit cao
			C1=vp0;
			C2=vp1|0xfc;
			delay(2);
		}
	} 
	delay(5);
}

/*********************** End Ctr hieu ung ******************************/
unsigned char p;
void INT_Timer0()interrupt 1 {//Ctr ngat Timer chay duong vien
	TF0=0; //Xoa co tran
	/* Duong vien 3bit*/
	if(p==0){DV1=0;DV2=1;DV3=1;}
	else if(p==2){DV1=1;DV2=0;DV3=1;}
	else if(p==4){DV1=1;DV2=1;DV3=0;}
	if(++p>5)p=0;
	//End DV 3bit
	/* Duong vien 8bit*/
	if(++e>100){if(++dv>5)dv=0; f=e=0;}	 
	if(dv==0){
		DV8=m3[f];
		if(++f>7)f=0;
	}else if(dv==1){
		DV8=m4[7-f];
		if(++f>7)f=0;
	}else if(dv==2){
		DV8=m3[7-f];
		if(++f>7)f=0;
	}else if(dv==3){
		if(f<=7)DV8=m1[f];
		else DV8=m5[f-8];
		if(f==15)f=0;
		f++;
	}else if(dv==4){
		DV8=m4[f];
		if(++f>7)f=0;
	}else if(dv==5){
		if(f==0)DV8=0x55;
		else if(f==2)DV8=0xAA;
		if(++f>3)f=0;
	}
	//End DV 8bit	
}
/*********************** Ctr chinh **********************************/ 
void main(){  
	TMOD=0x01;//Timer0 (ngat timer duong vien)
	C1=0x00;C2=0xfc;//Sang ALL de test LED
	delay(10);
    TR0=1;//Khoi dong timer0
    ET0=1;//Ngat timer0
	EA=1;//Cho phep ngat
	while(1){//Hieu ung lap lai o vong lap nay..
		//Cac ctr hieu ung sap xep tuy y
		lan_luot();
		quet_led();	
		nhay_chu();	
		xep_led();
		nhap_nhay(5);
		nhay_dep();
	 	lan_luot();
	 	xen_ke();
	 	nhap_nhay(5);
		duoi_nhau();
	 }
}
/*********************** The end **********************************/ 